package com.company.jmixbarcodereport.screen.barcodeentity;

import com.google.zxing.BarcodeFormat;
import com.google.zxing.client.j2se.MatrixToImageWriter;
import com.google.zxing.common.BitMatrix;
import com.google.zxing.oned.Code128Writer;
import com.google.zxing.oned.EAN13Writer;
import io.jmix.core.FileRef;
import io.jmix.core.FileStorage;
import io.jmix.ui.component.HasValue;
import io.jmix.ui.model.DataContext;
import io.jmix.ui.screen.*;
import com.company.jmixbarcodereport.entity.BarcodeEntity;
import org.springframework.beans.factory.annotation.Autowired;

import javax.imageio.ImageIO;
import java.awt.image.BufferedImage;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.InputStream;

@UiController("BarcodeEntity.edit")
@UiDescriptor("barcode-entity-edit.xml")
@EditedEntityContainer("barcodeEntityDc")
public class BarcodeEntityEdit extends StandardEditor<BarcodeEntity> {

    @Autowired
    private FileStorage fileStorage;

    @Subscribe(target = Target.DATA_CONTEXT)
    public void onPreCommit(final DataContext.PreCommitEvent event) throws Exception {
        BarcodeEntity barcodeEntity = getEditedEntity();

        InputStream inputStream = generateEAN13File(barcodeEntity.getBarcodeText());

        FileRef fileRef = fileStorage.saveStream("barcode.jpg", inputStream);
        barcodeEntity.setBarcode(fileRef);
    }


    public InputStream generateEAN13File(String barcodeText) throws Exception {
        Code128Writer barcodeWriter = new Code128Writer();
        BitMatrix bitMatrix = barcodeWriter.encode(barcodeText, BarcodeFormat.CODE_128, 300, 150);

        BufferedImage bufferedImage = MatrixToImageWriter.toBufferedImage(bitMatrix);

        ByteArrayOutputStream os = new ByteArrayOutputStream();
        ImageIO.write(bufferedImage, "jpeg", os);
        return new ByteArrayInputStream(os.toByteArray());
    }

}